Attribute VB_Name = "modSavePicture"
Option Explicit

'----------------------------------------------------
' Much thanks to Christoph von Wittich the idea of
' this code!
'----------------------------------------------------

Private Type GUID
    Data1       As Long
    Data2       As Integer
    Data3       As Integer
    Data4(7)    As Byte
End Type

Private Type PictDesc
    cbSizeofStruct  As Long
    picType         As Long
    hImage          As Handle
    xExt            As Long
    yExt            As Long
End Type
'----------------------------------------------------

Private Declare Function OleCreatePictureIndirect Lib "olepro32.dll" ( _
    PicDesc As PictDesc, _
    RefIID As GUID, _
    ByVal fPictureOwnsHandle As Long, _
    IPic As IPicture _
) As Long
'----------------------------------------------------

'----------------------------------------------------
' SaveDC
' saves the plot into a bitmap file
' - [IN] Obj AS CPlotFunction: object to save
' - [IN] FileName As String: file to store bitmap in
'----------------------------------------------------
Public Sub SaveDC(Obj As CPlotFunction, FileName As String)
    Dim IID_IDispatch   As GUID
    Dim hBitmap         As Handle
    Dim hBmpPrev        As Handle
    Dim Bitmap          As PictDesc
    Dim Picture         As IPicture
    
    hBitmap = CreateCompatibleBitmap( _
        Obj.m_Drawing.DC, _
        Obj.m_Drawing.Width, _
        Obj.m_Drawing.Height _
    )
    hBmpPrev = SelectObject(Obj.m_Drawing.DC, hBitmap)
    Call Obj.Render
    hBitmap = SelectObject(Obj.m_Drawing.DC, hBmpPrev)
    
    Bitmap.hImage = hBitmap
    Bitmap.picType = vbPicTypeBitmap
    Bitmap.cbSizeofStruct = LenB(Bitmap)
    
    IID_IDispatch.Data1 = &H20400
    IID_IDispatch.Data4(0) = &HC0
    IID_IDispatch.Data4(7) = &H46
    
    Call OleCreatePictureIndirect( _
        Bitmap, IID_IDispatch, 1, Picture _
    )
    
    Call SavePicture(Picture, FileName)
End Sub
