VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CFile"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Enum OpenFlags
    OF_CREATENEW        ' creates a file, erases if existing
    OF_OPENCREATE       ' creates a file, opens existing
    OF_OPENEXISTING     ' opens existing, fails if not exisiting
    OF_CREATEANDCLOSE   ' creates a new file (erasing existing) and closes it
End Enum
#If False Then
    Const OF_CREATENEW = 0
    Const OF_OPENCREATE = 1
    Const OF_OPENEXISTING = 2
    Const OF_CREATEANDCLOSE = 3
#End If

Private mHandle     As Long
Private mFileName   As String
Private mAttr       As VbFileAttribute      ' no use yet

Private mRead       As CReadStream
Private mWrite      As CWriteStream

'----------------------------------------------------
Private Sub Class_Terminate()
    If mHandle Then _
        Call CloseFile
End Sub

'----------------------------------------------------
Public Function OpenFile( _
  File As String, _
  Optional Flags As OpenFlags = OF_OPENCREATE _
) As Long
    On Error GoTo ERR_OPEN
    
    If mHandle Then _
        Call CloseFile
    
    mHandle = FreeFile
    mFileName = File
    
    If Exists(mFileName) Then
        If (Flags = OF_CREATENEW) Or (Flags = OF_CREATEANDCLOSE) Then _
            Call Delete(File)
    Else
        If (Flags = OF_OPENEXISTING) Then _
            Exit Function
    End If
    
    Open File For Binary As #mHandle
    If Flags = OF_CREATEANDCLOSE Then
        Close #mHandle
        mHandle = 0
    Else
        Set mRead = New CReadStream
        Set mWrite = New CWriteStream
        
        mRead.init__ mHandle
        mWrite.init__ mHandle
    End If
    
    OpenFile = mHandle
    On Error GoTo 0
    
    Exit Function
    
ERR_OPEN:
    Call CloseFile
    On Error GoTo 0
End Function

Public Sub CloseFile()
    On Error GoTo ERR_CLOSE
    
    If mHandle Then
        Close #mHandle
        mHandle = 0
        
        Set mRead = Nothing
        Set mWrite = Nothing
    End If
    
ERR_CLOSE:
    On Error GoTo 0
End Sub

'----------------------------------------------------

Public Property Get InputStream() As CReadStream
    Set InputStream = mRead
End Property

Public Property Get OutputStream() As CWriteStream
    Set OutputStream = mWrite
End Property

Public Property Get Size() As Long
    If mHandle Then _
        Size = LOF(mHandle)
End Property

'----------------------------------------------------
' thanks to http://vb-tec.de
Public Function Exists(File As String) As Boolean
    On Error Resume Next
    Exists = (GetAttr(File) And (vbDirectory Or vbVolume)) = 0
    On Error GoTo 0
End Function

Public Function Delete(File As String) As Boolean
    On Error Resume Next
    Call SetAttr(File, vbNormal)
    Call Kill(File)
    Delete = (Err.Number = 0)
    On Error GoTo 0
End Function

