VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CReadStream"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private Declare Sub Poke Lib "kernel32" Alias "RtlMoveMemory" ( _
  ByVal lpDest As Long, _
  nSrc As Any, _
  ByVal nLen As Long _
)

Private mHandle     As Long
Private mPos        As Long

'----------------------------------------------------
Friend Sub init__(Handle As Long)
    mHandle = Handle
    mPos = 1
End Sub

'----------------------------------------------------
'----------------------------------------------------
' ReadFile As String
' returns the whole content of the file
'----------------------------------------------------
Public Function ReadFile() As String
    If mHandle Then
        mPos = LOF(mHandle)
        ReadFile = String$(mPos, 0)
        Get #mHandle, 1, ReadFile
        mPos = mPos + 1
    End If
End Function

'----------------------------------------------------
' ReadToEnd As String
' returns the remaining file's content, beginning
' at the pointer's position
'----------------------------------------------------
Public Function ReadToEnd() As String
    Dim nLen    As Long
    
    If mHandle Then
        nLen = LOF(mHandle) - mPos + 1
        If nLen > 0 Then
            ReadToEnd = String$(nLen, 0)
            Get #mHandle, mPos, ReadToEnd
            mPos = LOF(mHandle) + 1
        End If
    End If
End Function

'----------------------------------------------------
' ReadLine As String
' returns a single line of the file, delimited by vb(Cr)Lf
' Unix As Boolean - indicates whether a line is delimited
'   by vbCrLf (False) or vbLf (True)
'----------------------------------------------------
Public Function ReadLine( _
  Optional Unix As Boolean = False _
) As String
    Dim Char    As String * 1
    Dim inPos   As Long
    
    If mHandle Then
        ReadLine = String$(LOF(mHandle) - mPos + 1, 0)
        inPos = 1
        
        Do Until mPos > LOF(mHandle)
            Get #mHandle, mPos, Char
            mPos = mPos + 1
            If Char <> vbCr And Char <> vbLf Then
                MidB$(ReadLine, inPos, 2) = Char
                inPos = inPos + 2
            ElseIf Char = vbLf Then
                If Unix Then _
                    Exit Do
            Else
                Get #mHandle, mPos, Char
                mPos = mPos + 1
                
                If Char = vbLf Then
                    Exit Do
                Else
                    MidB$(ReadLine, inPos, 2) = Char
                    inPos = inPos + 2
                End If
            End If
        Loop
        
        If mPos < LOF(mHandle) Then
            If Unix Then
                MidB$(ReadLine, inPos, 2) = vbCr
                inPos = inPos + 2
            End If
        End If
    End If
    
    On Error Resume Next
    ReadLine = LeftB$(ReadLine, inPos)
    On Error GoTo 0
End Function

'----------------------------------------------------
' ReadString As String
' reads a string
' Size As Long - indicates the string's size
'----------------------------------------------------
Public Function ReadString( _
  ByVal Size As Long _
) As String
    If mHandle Then
        If Size > LOF(mHandle) - mPos + 1 Then _
            Size = LOF(mHandle) - mPos + 1
        
        If Size <= 0 Then _
            Size = LOF(mHandle) - mPos
        
        ReadString = String$(Size, 0)
        Get #mHandle, mPos, ReadString
        mPos = mPos + Size
    End If
End Function

'----------------------------------------------------
' ReadBuffer As String
' reads a byte array
' Size As Long - indicates the buffer's size
'----------------------------------------------------
Public Function ReadBuffer( _
  ByVal Size As Long _
) As Byte()
    Dim tmpBuffer() As Byte
    
    If mHandle Then
        If Size > LOF(mHandle) - mPos + 2 Then _
            Size = LOF(mHandle) - mPos + 2
        
        If Size <= 0 Then _
            Size = LOF(mHandle) - mPos
        
        ReDim tmpBuffer(Size - 1) As Byte
        
        Get #mHandle, mPos, tmpBuffer
        mPos = mPos + Size
        
        ReadBuffer = tmpBuffer
    End If
End Function

'----------------------------------------------------
' ReadStruct As Boolean
' reads a structure
' returns success
' lpStruct As Long - long pointer to the struture
'   to write into
' Size As Long - the size of the structure
'   !!! size is LenB(struct) !!!
'----------------------------------------------------
Public Function ReadStruct( _
 lpStruct As Long, _
 Size As Long _
) As Boolean
    Dim tmpBuffer() As Byte
    
    tmpBuffer = ReadBuffer(Size)
    If UBound(tmpBuffer) + 1 = Size Then
        Call Poke(lpStruct, tmpBuffer(0), Size)
        ReadStruct = True
    End If
End Function

'----------------------------------------------------
'----------------------------------------------------
' ReadChar As Byte
' reads a single byte
'----------------------------------------------------
Public Function ReadChar() As Byte
    If mHandle Then
        If mPos < LOF(mHandle) + 1 Then
            Get #mHandle, mPos, ReadChar
            mPos = mPos + 1
        End If
    End If
End Function

'----------------------------------------------------
' ReadWord As Integer
' reads a single integer
'----------------------------------------------------
Public Function ReadWord() As Integer
    If mHandle Then
        If mPos < LOF(mHandle) Then
            Get #mHandle, mPos, ReadWord
            mPos = mPos + 2
        End If
    End If
End Function

'----------------------------------------------------
' ReadDWord As Long
' reads a single long
'----------------------------------------------------
Public Function ReadDWord() As Long
    If mHandle Then
        If mPos < LOF(mHandle) - 2 Then
            Get #mHandle, mPos, ReadDWord
            mPos = mPos + 4
        End If
    End If
End Function

'----------------------------------------------------
'----------------------------------------------------
' Pointer - Property Long
' sets or retrieves the current file read pointer
'   (zerobased)
'----------------------------------------------------
Public Property Get Pointer() As Long
    Pointer = mPos - 1
End Property

Public Property Let Pointer(newPointer As Long)
    If mHandle Then
        mPos = newPointer + 1
        
        If mPos < 1 Then _
            mPos = 1
        If mPos > LOF(mHandle) Then _
            mPos = LOF(mHandle)
    End If
End Property

'----------------------------------------------------
' EOF - ReadOnly Property Boolean
' returns whether the end of file is reached
'----------------------------------------------------
Public Property Get EOF() As Boolean
    EOF = (mPos > LOF(mHandle))
End Property

