VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CTree"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Private mRoot   As CTreeNode
'----------------------------------------------------

Private Sub Class_Initialize()
    Set mRoot = New CTreeNode
    
    mRoot.Key = "Root"
End Sub

Private Sub Class_Terminate()
    Set mRoot = Nothing
End Sub
'----------------------------------------------------

' implements the important CTreeNode properties and functions

Public Property Get Count() As Long
    Count = mRoot.Count
End Property

Public Property Get Nodes() As CTreeNode
    Set Nodes = mRoot.Nodes
End Property

Public Function Add( _
  Key As String, _
  Optional Value As String _
) As CTreeNode
    Set Add = mRoot.Add(Key, Value)
End Function

Public Function Remove(Key As String) As Boolean
    Remove = mRoot.Remove(Key)
End Function

' Procedure-Attribute (Default)
Public Function Item(Key As String) As CTreeNode
Attribute Item.VB_UserMemId = 0
    Set Item = mRoot.Item(Key)
End Function

Public Sub Clear()
    mRoot.Clear
End Sub

Public Function ExportXML( _
  Path As String, _
  Optional Key As String _
) As Boolean
    ExportXML = mRoot.ExportXML(Path, Key)
End Function

Public Function ImportXML( _
  Path As String _
) As Boolean
    ImportXML = mRoot.ImportXML(Path)
End Function

