VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CDoubleStack"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'****************************************************
'* CDoubleStack.cls                                 *
'* simple stack for Double values                   *
'* Programmed: Konrad Rudolph (Mad Rat Pro.)        *
'* Last Change: 25.08.2003 15:18                    *
'* Version: 1.0.0                                   *
'****************************************************
Option Explicit

Private Const CLASSNAME As String = "CDoubleStack"

Private m_Stack()       As Double
Private m_lOffset       As Long
'----------------------------------------------------

Private Sub Class_Initialize()
    Call Clear
End Sub

Private Sub Class_Terminate()
    Call Clear
End Sub
'----------------------------------------------------

Public Sub Clear()
    m_lOffset = 0
    Erase m_Stack
    ReDim m_Stack(1000) As Double
End Sub

Public Sub Push(Item As Double)
    If m_lOffset > UBound(m_Stack) Then _
        ReDim Preserve m_Stack(m_lOffset + 1000) As Double
    
    m_Stack(m_lOffset) = Item
    m_lOffset = m_lOffset + 1
End Sub

Public Function Pop() As Double
    If CBool(m_lOffset) Then
        m_lOffset = m_lOffset - 1
        Pop = m_Stack(m_lOffset)
    Else
        Call Err.Raise( _
            vbObjectError, CLASSNAME, _
            "Cannot pop from empty stack." _
        )
    End If
End Function

Public Property Get Peek() As Double
    If CBool(m_lOffset) Then _
        Peek = m_Stack(m_lOffset - 1) _
    Else _
        Call Err.Raise( _
            vbObjectError, CLASSNAME, _
            "Cannot peek from empty stack." _
        )
End Property

Public Property Get Count() As Long
    Count = m_lOffset
End Property
'----------------------------------------------------

Public Function Execute(Operator As String) As Double
    Dim tmpReg  As Double
    
    Select Case Operator
        Case OP_ADD
            tmpReg = Me.Pop
            Call Me.Push(Me.Pop + tmpReg)
        Case OP_DIFF
            tmpReg = Me.Pop
            Call Me.Push(Me.Pop - tmpReg)
        Case OP_MUL
            tmpReg = Me.Pop
            Call Me.Push(Me.Pop * tmpReg)
        Case OP_DIV
            tmpReg = Me.Pop
            Call Me.Push(Me.Pop / tmpReg)
        Case OP_IDIV
            tmpReg = Me.Pop
            Call Me.Push(Me.Pop \ tmpReg)
        Case OP_MOD
            tmpReg = Me.Pop
            Call Me.Push(CLng(Me.Pop) Mod CLng(tmpReg))
        Case OP_POW
            tmpReg = Me.Pop
            Call Me.Push(Me.Pop ^ tmpReg)
        Case OP_ROOT
            tmpReg = Me.Pop
            Call Me.Push(Me.Pop ^ (1 / tmpReg))
        Case OP_AND
            tmpReg = Me.Pop
            Call Me.Push(Me.Pop And tmpReg)
        Case OP_OR
            tmpReg = Me.Pop
            Call Me.Push(Me.Pop Or tmpReg)
        Case OP_XOR
            tmpReg = Me.Pop
            Call Me.Push(Me.Pop Xor tmpReg)
        Case Else
    End Select ' Operator
    
    Execute = Me.Peek
End Function

Public Function ExecFunct(Funct As String) As Double
    Select Case Funct
        Case FN_SIN
            Call Me.Push(Sin(Me.Pop))
        Case FN_COS
            Call Me.Push(Cos(Me.Pop))
        Case FN_TAN
            Call Me.Push(Tan(Me.Pop))
        Case FN_ATN
            Call Me.Push(Atn(Me.Pop))
        Case FN_EXP
            Call Me.Push(Exp(Me.Pop))
        Case FN_LN
            Call Me.Push(Log(Me.Pop))
        Case FN_LOG
            Call Me.Push(Log(Me.Pop) / Log(10))
        Case FN_SGN
            Call Me.Push(Sgn(Me.Pop))
        Case FN_FIX
            Call Me.Push(Fix(Me.Pop))
        Case FN_ABS
            Call Me.Push(Abs(Me.Pop))
        Case FN_SQR
            Call Me.Push(Sqr(Me.Pop))
        Case FN_NOT
            Call Me.Push(Not Me.Pop)
    End Select
    
    ExecFunct = Me.Peek
End Function
