VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CStringStack"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'****************************************************
'* CStringStack.cls                                 *
'* simple stack for String values                   *
'* Programmed: Konrad Rudolph (Mad Rat Pro.)        *
'* Last Change: 25.08.2003 15:18                    *
'* Version: 1.0.0                                   *
'****************************************************
Option Explicit

Private Const CLASSNAME As String = "CStringStack"

Private m_Stack()       As String
Private m_lOffset       As Long
'----------------------------------------------------

Private Sub Class_Initialize()
    Call Clear
End Sub

Private Sub Class_Terminate()
    Call Clear
End Sub
'----------------------------------------------------

Public Sub Clear()
    m_lOffset = 0
    Erase m_Stack
    ReDim m_Stack(1000) As String
End Sub

Public Sub Push(Item As String)
    If m_lOffset > UBound(m_Stack) Then _
        ReDim Preserve m_Stack(m_lOffset + 1000) As String
    
    m_Stack(m_lOffset) = Item
    m_lOffset = m_lOffset + 1
End Sub

Public Function Pop() As String
    If CBool(m_lOffset) Then
        m_lOffset = m_lOffset - 1
        Pop = m_Stack(m_lOffset)
    Else
        Call Err.Raise( _
            vbObjectError, CLASSNAME, _
            "Cannot pop from empty stack." _
        )
    End If
End Function

Public Property Get Peek() As String
    If CBool(m_lOffset) Then _
        Peek = m_Stack(m_lOffset - 1) _
    Else _
        Call Err.Raise( _
            vbObjectError, CLASSNAME, _
            "Cannot peek from empty stack." _
        )
End Property

Public Property Get Count() As Long
    Count = m_lOffset
End Property
