VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CBackBuffer"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'****************************************************
'* CBackBuffer.cls                                  *
'* backbuffer class                                 *
'* Programmed: Konrad Rudolph (Mad Rat Pro.)        *
'* Last Change: 25.08.2003 15:44                    *
'* Version: 1.0.0                                   *
'****************************************************
Option Explicit

Private m_hMemoryDC As hDC
Private m_hBitmap   As HANDLE, _
        m_hOldBMP   As HANDLE
Private m_lWidth    As Long, _
        m_lHeight   As Long
Private m_bInit     As Boolean
'----------------------------------------------------

Public Property Get DC() As hDC
    DC = m_hMemoryDC
End Property
'----------------------------------------------------

'----------------------------------------------------
' CreateBuffer
' creates a backbuffer DC
' - [IN] MirrorDC As hDC: frontbuffer DC
' - [IN] Width As Long: the DC's with
' - [IN] Height As Long: the DC's height
'----------------------------------------------------
Public Sub CreateBuffer( _
  MirrorDC As hDC, _
  Width As Long, _
  Height As Long _
)
    m_lWidth = Width
    m_lHeight = Height
    
    Call DeleteBuffer
    
    m_hMemoryDC = CreateCompatibleDC(MirrorDC)
    m_hBitmap = CreateCompatibleBitmap(MirrorDC, Width, Height)
    m_hOldBMP = SelectObject(m_hMemoryDC, m_hBitmap)
    
    m_bInit = True
End Sub

'----------------------------------------------------
' DeleteBuffer
' deletes the backbuffer DC
'----------------------------------------------------
Public Sub DeleteBuffer()
    If m_bInit Then
        Call SelectObject(m_hMemoryDC, m_hOldBMP)
        Call GDIDeleteObject(m_hBitmap)
        Call DeleteDC(m_hMemoryDC)
        m_bInit = False
    End If
End Sub

'----------------------------------------------------
' BltDC
' flips the backbuffer to the front buffer
' - [IN] Target As DC: target
'----------------------------------------------------
Public Sub BltDC(Target As hDC)
    If m_bInit Then _
        Call BitBlt( _
            Target, 0, 0, _
            m_lWidth, m_lHeight, _
            m_hMemoryDC, 0, 0, _
            vbSrcCopy _
        )
End Sub
'----------------------------------------------------

Private Sub Class_Terminate()
    Call DeleteBuffer
End Sub
