VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CObjectsGDI"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'****************************************************
'* CObjectsGDI.cls                                  *
'* stack of gradent objects                         *
'* Programmed: Konrad Rudolph (Mad Rat Pro.)        *
'* Last Change: 25.08.2003 16:21                    *
'* Version: 1.0.0                                   *
'****************************************************
Option Explicit

Private Const CLASSNAME As String = "CObjectsGDI"

Private Type IndexTable
    Data    As HANDLE
    Enabled As Boolean
End Type

Private m_Stack()       As IndexTable
'----------------------------------------------------

Private Sub Class_Initialize()
    Call Clear
End Sub

Private Sub Class_Terminate()
    Call Clear
End Sub
'----------------------------------------------------

Public Sub Clear()
    Erase m_Stack
    ReDim m_Stack(1000) As IndexTable
End Sub

Public Function Add(Item As HANDLE) As HANDLE
    Add = GetFreeSlot()
    
    m_Stack(Add).Data = Item
    m_Stack(Add).Enabled = True
End Function

Public Property Get Item(Index As HANDLE) As HANDLE
    If Index < UBound(m_Stack) Then
        If m_Stack(Index).Enabled Then _
            Item = m_Stack(Index).Data
    End If ' Index < m_lOffset
End Property

Public Sub Remove(Index As HANDLE)
    If Index < UBound(m_Stack) Then _
        m_Stack(Index).Enabled = False
End Sub

Public Property Get Count() As Long
    Count = UBound(m_Stack)
End Property
'----------------------------------------------------

Private Function GetFreeSlot() As HANDLE
    For GetFreeSlot = 0 To UBound(m_Stack)
        If Not m_Stack(GetFreeSlot).Enabled Then _
            Exit Function
    Next GetFreeSlot
    
    ' no free slot - enlarge stack
    ReDim Preserve m_Stack(UBound(m_Stack) + 1000) As IndexTable
End Function
