Attribute VB_Name = "modGDI"
Option Explicit

#If False Then ' only needed if not ActiveX Dll

Public Enum hWnd
    [_]
End Enum
Public Enum hDC
    [_]
End Enum
Public Enum HANDLE
    [_]
End Enum
Public Enum HFILE
    [_]
End Enum
Public Enum POINTER
    [_]
End Enum

Public Enum BOOL
    [False] = 0
    [True] = 1
End Enum

Public Enum PenStyles
    PS_SOLID = 0
    PS_DASH = 1
    PS_DOT = 2
    PS_DASHDOT = 3
    PS_DASHDOTDOT = 4
    PS_NULL = 5
    PS_INSIDEFRAME = 6
End Enum

Public Enum BrushStyles
    BS_DIBPATTERN = 5
    BS_DIBPATTERN8X8 = 8
    BS_DIBPATTERNPT = 6
    BS_HATCHED = 2
    BS_HOLLOW = 1
    BS_NULL = 1
    BS_PATTERN = 3
    BS_PATTERN8X8 = 7
    BS_SOLID = 0
End Enum

Public Enum HatchStyle
    HS_HORIZONTAL = 0
    HS_VERTICAL = 1
    HS_FDIAGONAL = 2
    HS_BDIAGONAL = 3
    HS_CROSS = 4
    HS_DIAGCROSS = 5
End Enum

Public Enum FontWeight
    FW_DONTCARE = 0
    FW_THIN = 100
    FW_EXTRALIGHT = 200
    FW_ULTRALIGHT = 200
    FW_LIGHT = 300
    FW_NORMAL = 400
    FW_REGULAR = 400
    FW_MEDIUM = 500
    FW_SEMIBOLD = 600
    FW_DEMIBOLD = 600
    FW_BOLD = 700
    FW_EXTRABOLD = 800
    FW_ULTRABOLD = 800
    FW_HEAVY = 900
    FW_BLACK = 900
End Enum

Public Enum CharSet
    ANSI_CHARSET = 0
    DEFAULT_CHARSET = 1
    OEM_CHARSET = 255
'    BALTIC_CHARSET
'    CHINESEBIG5_CHARSET
'    DEFAULT_CHARSET
'    EASTEUROPE_CHARSET
'    GB2312_CHARSET
'    GREEK_CHARSET
'    HANGUL_CHARSET
'    MAC_CHARSET
'    OEM_CHARSET
'    RUSSIAN_CHARSET
'    SHIFTJIS_CHARSET
'    SYMBOL_CHARSET
'    TURKISH_CHARSET
'    VIETNAMESE_CHARSET
End Enum

Public Enum OutputPrecision
    OUT_DEFAULT_PRECIS = 0
    OUT_STRING_PRECIS = 1
    OUT_CHARACTER_PRECIS = 2
    OUT_STROKE_PRECIS = 3
    OUT_TT_PRECIS = 4
    OUT_DEVICE_PRECIS = 5
    OUT_RASTER_PRECIS = 6
    OUT_TT_ONLY_PRECIS = 7
    OUT_OUTLINE_PRECIS = 8
    OUT_SCREEN_OUTLINE_PRECIS = 9
    OUT_PS_ONLY_PRECIS = 10
End Enum

Public Enum ClipPrecision
    CLIP_DEFAULT_PRECIS = 0
    CLIP_CHARACTER_PRECIS = 1
    CLIP_STROKE_PRECIS = 2
    CLIP_MASK = &HF
    CLIP_LH_ANGLES = 16
    CLIP_TT_ALWAYS = 32
    CLIP_EMBEDDED = 128
End Enum

Public Enum FontQuality
    DEFAULT_QUALITY = 0
    DRAFT_QUALITY = 1
    PROOF_QUALITY = 2
    NONANTIALIASED_QUALITY = 3
    ANTIALIASED_QUALITY = 4
End Enum
'----------------------------------------------------

Public Type RECT
    Left            As Long
    Top             As Long
    Right           As Long
    Bottom          As Long
End Type

Public Type POINTAPI
    x               As Long
    y               As Long
End Type

Public Type POINT3D
    x               As Long
    y               As Long
    z               As Long
End Type

Public Type LOGBRUSH
    lbStyle         As Long
    lbColor         As Long
    lbHatch         As Long
End Type

Public Type XFORM
    eM11            As Double
    eM12            As Double
    eM21            As Double
    eM22            As Double
    eDx             As Double
    eDy             As Double
End Type

#End If '----------------------------------------------------

Public Const NULL_HANDLE    As Long = 0
'----------------------------------------------------

' API declarations

' gdi32
Public Declare Function SelectObject Lib "gdi32.dll" ( _
  ByVal hDC As hDC, _
  ByVal hObject As HANDLE _
) As Long
Private Declare Function DeleteObject Lib "gdi32.dll" ( _
  ByVal hObject As HANDLE _
) As BOOL
Public Declare Function CreateCompatibleDC Lib "gdi32.dll" ( _
  ByVal hDC As hDC _
) As hDC
Public Declare Function DeleteDC Lib "gdi32.dll" ( _
  ByVal hDC As hDC _
) As BOOL
Public Declare Function CreateCompatibleBitmap Lib "gdi32.dll" ( _
  ByVal hDC As hDC, _
  ByVal nWidth As Long, _
  ByVal nHeight As Long _
) As Long
Public Declare Function BitBlt Lib "gdi32.dll" ( _
  ByVal hDestDC As hDC, _
  ByVal x As Long, _
  ByVal y As Long, _
  ByVal nWidth As Long, _
  ByVal nHeight As Long, _
  ByVal hSrcDC As hDC, _
  ByVal xSrc As Long, _
  ByVal ySrc As Long, _
  ByVal dwRop As RasterOpConstants _
) As Long
Public Declare Function CreateBrushIndirect Lib "gdi32.dll" ( _
  lpLogBrush As LOGBRUSH _
) As HANDLE

Public Declare Function CreatePen Lib "gdi32.dll" ( _
  ByVal nPenStyle As Long, _
  ByVal nWidth As Long, _
  ByVal crColor As OLE_COLOR _
) As HANDLE
Public Declare Function CreateSolidBrush Lib "gdi32.dll" ( _
  ByVal crColor As OLE_COLOR _
) As HANDLE

Public Declare Function CreateFont Lib "gdi32.dll" Alias "CreateFontA" ( _
  ByVal nHeight As Long, _
  ByVal nWidth As Long, _
  ByVal nEscapement As Long, _
  ByVal nOrientation As Long, _
  ByVal fnWeight As FontWeight, _
  ByVal fdwItalic As BOOL, _
  ByVal fdwUnderline As BOOL, _
  ByVal fdwStrikeOut As BOOL, _
  ByVal fdwCharSet As CharSet, _
  ByVal fdwOutputPrecision As OutputPrecision, _
  ByVal fdwClipPrecision As ClipPrecision, _
  ByVal fdwQuality As FontQuality, _
  ByVal fdwPitchAndFamily As Long, _
  ByVal lpszFace As String _
) As HANDLE
Public Declare Function SetTextColor Lib "gdi32.dll" ( _
  ByVal hDC As hDC, _
  ByVal crColor As OLE_COLOR _
) As OLE_COLOR
Public Declare Function GetTextColor Lib "gdi32.dll" ( _
  ByVal hDC As hDC _
) As OLE_COLOR
Public Declare Function TextOut Lib "gdi32.dll" Alias "TextOutA" ( _
  ByVal hDC As hDC, _
  ByVal x As Long, _
  ByVal y As Long, _
  ByVal lpString As String, _
  ByVal nCount As Long _
) As BOOL
Public Declare Function GetDeviceCaps Lib "gdi32.dll" ( _
  ByVal hDC As Long, _
  ByVal nIndex As Long _
) As Long

' user32
Public Declare Function FillRect Lib "user32.dll" ( _
  ByVal hDC As hDC, _
  lpRect As RECT, _
  ByVal hBrush As HANDLE _
) As Long
Public Declare Function GetDC Lib "user32.dll" ( _
  ByVal hWnd As hWnd _
) As hDC
Public Declare Function ReleaseDC Lib "user32.dll" ( _
  ByVal hWnd As hWnd, _
  ByVal hDC As hDC _
) As Long

' kernel32
Public Declare Function MulDiv Lib "kernel32.dll" ( _
  ByVal nNumber As Long, _
  ByVal nNumerator As Long, _
  ByVal nDenominator As Long _
) As Long
Public Declare Sub Peek Lib "kernel32" Alias "RtlMoveMemory" ( _
  nDest As Any, _
  ByVal lpSrc As POINTER, _
  ByVal nLen As Long _
)
'----------------------------------------------------

Public Const LOGPIXELSY As Long = 90
'----------------------------------------------------

Private m_Colour    As OLE_COLOR
Private m_bNotStart As Boolean
Private m_Brush     As HANDLE
'----------------------------------------------------

'----------------------------------------------------
' Clear
' clears a device context with a colour
' - [IN] Target As hDC: handle to target DC
' - [IN] Colour As OLE_COLOR: background colour
' - [IN] Width As Long: the DC's width
' - [IN] Height As Long: the DC's height
'----------------------------------------------------
Public Sub Clear( _
  Target As hDC, _
  Colour As OLE_COLOR, _
  Width As Long, _
  Height As Long _
)
    Dim WndRect As RECT
    
    With WndRect
        .Right = Width
        .Bottom = Height
    End With
    
    If Not m_bNotStart Or Colour <> m_Colour Then _
        Call MakeClearBuffer(Colour)
    
    Call FillRect(Target, WndRect, m_Brush)
End Sub

'----------------------------------------------------
' DeleteGDIObjects
' deletes the clearing brush
'----------------------------------------------------
Public Sub DeleteGDIObjects()
    If m_bNotStart Then
        Call GDIDeleteObject(m_Brush)
        m_bNotStart = False
    End If
End Sub

'----------------------------------------------------
' GDIDeleteObject
' deletes a selected GDI object - maps the
' DeleteObject() API
' - [IN] GDIObj As HANDLE: object to delete
'----------------------------------------------------
Public Sub GDIDeleteObject(GDIObj As HANDLE)
    Dim ret As BOOL
    
    ret = DeleteObject(GDIObj)
    
    Debug.Assert ret
    If ret = [False] Then
        Debug.Print "Object '" & CStr(GDIObj) & "' not deleted."
    End If
End Sub
'----------------------------------------------------

'----------------------------------------------------
' MakeClearBuffer
' creates a brush for the clearing
' - [IN] Colour AS OLE_COLOR: background colour
'----------------------------------------------------
Private Sub MakeClearBuffer(Colour As OLE_COLOR)
    Dim Brush As LOGBRUSH
    
    Brush.lbColor = Colour
    
    If m_bNotStart Then _
        Call DeleteGDIObjects
    
    m_bNotStart = True
    m_Brush = CreateBrushIndirect(Brush)
End Sub
